<?php
function checkArch($filename) {
	
	$filename=$uploadpath.$filename;	
	$handle = fopen($filename, "rb");
	if(!$handle) {
	die('file not found');
	}
       $contents = fread($handle, filesize($filename));

	$magic_0=ord($contents[0]);
	$magic_1=ord($contents[1]);
	$magic_2=ord($contents[2]);
	$magic_3=ord($contents[3]);
	$magic_4=ord($contents[4]);
	
	if($magic_0==0x7f && $magic_1==0x45 && $magic_2==0x4C && $magic_3==0x46)	{
		//echo 'magic found\n';
	}
	else {
		sec_warning();
		return -1;
	}
	if($magic_4==0x01) {
		
		//print '32bit not supported <br>';
 		return 32;
	}
	if($magic_4==0x02) {
		//return 64;
		die('64bit not supported');
		//sec_warning();
	}
	sec_warning();

	retrun -1;
}
function getEntryPoint($contents) {
       
	global $readelfpath;
	global $objdumppath;	

	$output=shell_exec($readelfpath.' -h '.$contents); 

	$data = preg_match( '/0x[a-fA-F0-9]{5,8}/', $output,$matches);
	//$retValue=(hexdec($matches[0]) & 4294967288);
	$retValue=hexdec($matches[0]);
	return ($retValue );
}
function getDisassembly($contents){
	global $readelfpath;
	global $objdumppath;
	$output=shell_exec($objdumppath.' --disassemble '.$contents);
	return $output;
}
function getOpcodes($contents){
	print $contents;
	print "\n";
	$data = preg_match_all( '/[a-f0-9]{2}[\x20]/', $contents,$matches);
	$count=0;
	$retValue='';
	foreach ($matches[0] as $value) {
		$retValue.=$value;
		$count++;
		if($count==12) break;	
	}
	return $retValue;	
}
function checkSetup(){

	error_reporting(E_ALL);

	global $readelfpath;
	global $objdumppath;
	
	$handle = popen($readelfpath.' 2>&1', 'r');
	
	while (!feof($handle)) {
  		$read .= fread($handle, 8192);
	}	
	
	pclose($handle);

	if(strpos($read,"not found")){
		die("readelf not found");
	}
	

	$handle2 = popen($objdumppath.' 2>&1', 'r');
	while (!feof($handle2)) {
  	$read2 .= fread($handle2, 2);
	}
	pclose($handle2);
	
	if(strpos($read2,"not found")){
		die("objdump not found");
	}
}

?>